<?php

///////////////////////////////////////////////////////////////////////////////
// $Id: config.inc.php,v 1.1.1.1 2002/03/31 00:07:42 richy Exp $
///////////////////////////////////////////////////////////////////////////////
// $Log: config.inc.php,v $
// Revision 1.1.1.1  2002/03/31 00:07:42  richy
// Initial import into CVS (release rel-1_0).
//
///////////////////////////////////////////////////////////////////////////////

/**
* Configuration module.
*
* Sets the $config array, that's used throughout PICker. It will both set the_
* settings in config.ini, as well as set some hardcoded settings (like the_
* version and the path where PICker is installed).
*
* @module         Config
* @modulegroup    include
* @package        PICker
* @version        $Revision: 1.1.1.1 $
* @copyright      (c)2002 R.J. Vrijhof
* @magic          $Id: config.inc.php,v 1.1.1.1 2002/03/31 00:07:42 richy Exp $
* @access         public
*/

/**
* @include        Makes sure the config INI-file can be read/modified
*/
require_once("hIniFileReader.inc.php");
// Only one INI file: config.ini
$ini = new IniFileReader("./include/config.ini");

/**
* Retrieve own IP address with a system call (on Linux/Unix only).
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed     on success IP address, else false
* @access   public
*/
function getIP() {
  $out = `ifconfig ppp0 | grep "inet addr"`;
  if (eregi("^ +inet addr:([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})", $out, $regs)) {
    return $regs[1];
  } else {
    return false;
  }
}

/**
* Retrieve version number of this release of PICker.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed     on success string with version number, else false
* @access   public
*/
function getver() {
  return trim(str_replace("rel-", "", ereg_replace("_", ".", implode("", file("./RELEASE")))));
}

// Most important variable in PICker: the configuration settings.
$config = array(
  "version" => getver(),
  "lg_dir" => $ini->getIniFile("config", "lg_dir", ""),
  "prelude_log" => $ini->getIniFile("config", "prelude_log", ""),
  "from_addr" => $ini->getIniFile("config", "from_address", ""),
  "own_dir" => realpath("."),
  "own_IP" => ($ini->getIniFile("config", "own_IP", "") ? $ini->getIniFile("config", "own_IP", "") : getIP()),
  "db_host" => $ini->getIniFile("db", "host", "localhost"),
  "db_user" => $ini->getIniFile("db", "username", ""),
  "db_pass" => $ini->getIniFile("db", "password", ""),
  "db_name" => $ini->getIniFile("db", "name", "")
);

?>
