<?php

///////////////////////////////////////////////////////////////////////////////
// $Id: mysql.inc.php,v 1.1.1.1 2002/03/31 00:07:42 richy Exp $
///////////////////////////////////////////////////////////////////////////////
// $Log: mysql.inc.php,v $
// Revision 1.1.1.1  2002/03/31 00:07:42  richy
// Initial import into CVS (release rel-1_0).
//
///////////////////////////////////////////////////////////////////////////////

/**
* MySQL module for PICker to cache the already logged data.
*
* @module         MySQL
* @modulegroup    include
* @package        PICker
* @version        $Revision: 1.1.1.1 $
* @copyright      (c)2002 R.J. Vrijhof
* @magic          $Id: mysql.inc.php,v 1.1.1.1 2002/03/31 00:07:42 richy Exp $
* @access         public
*/

/**
* Link of the to be opened database connection.
*
* @var      integer     $db
* @access   private
* @see      db_open()
*/
$db = 0;

/**
* Open connection to MySQL server and select PICker database.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   boolean     on success true, else false
* @global   $config, $db
* @access   public
*/
function db_open() {
  global $config, $db;

  $db = mysql_connect($config[db_host], $config[db_user], $config[db_pass]);
  if (! $db) {
    return false;
  }
  mysql_select_db($config[db_name], $db);
  return true;
}

/**
* Get the last Loggrep access date (so you know which Loggrep files have to be cached).
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed       on success string in the format "yyyy-mm-dd",
*                       else false
* @global   $db
* @access   public
* @see      db_lg_set_last_access()
*/
function db_lg_get_last_access() {
  global $db;

  $result = mysql_query("SELECT lg_access FROM last", $db);
  if ($result) {
    if (mysql_num_rows($result)) {
      $row = mysql_fetch_row($result);
      return $row[0];
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Set the last access date for Loggrep.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_last_access()
*/
function db_lg_set_last_access($when) {
  global $db;

  $result = mysql_query(
    "UPDATE last SET lg_access='$when'",
    $db
  );
  if (! $result) {
    $result = mysql_query(
      "INSERT INTO last SET lg_access='$when'",
      $db
    );
    if ($result) {
      return true;
    } else {
      return false;
    }
  } else {
    return true;
  }
}

/**
* Get the id of a certain IP for Loggrep.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip   the IP address for which you want to know the id
* @return   mixed       on success integer with id, else false
* @global   $db
* @access   public
* @see      db_lg_get_ip()
*/
function db_lg_get_id($ip) {
  global $db;

  $result = mysql_query(
    "SELECT id FROM lg_ip WHERE ip='$ip'",
    $db
  );
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) > 1) {
        die("There may be only one...");
      } else {
        $row = mysql_fetch_row($result);
        return $row[0];
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Get the IP of a certain id for Loggrep.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    integer     $id   the id for which you want to know the IP address
* @return   mixed       on success string with IP, else false
* @global   $db
* @access   public
* @see      db_lg_get_id()
*/
function db_lg_get_ip($id) {
  global $db;

  $result = mysql_query(
    "SELECT ip FROM lg_ip WHERE id='$id'",
    $db
  );
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) > 1) {
        die("IP address not unique in lg_ip table");
      } else {
        $row = mysql_fetch_row($result);
        return $row[0];
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Get all logged IPs from the Loggrep cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed       on success array with the IPs (IP => count), else false
* @global   $db
* @access   public
* @see      db_lg_new_ip()
*/
function db_lg_get_ips($ipsort = false) {
  global $db;

  $result = mysql_query(
    "SELECT ip,count FROM lg_ip",
    $db
  );
  if (! $result) {
    return false;
  }
  if (! mysql_num_rows($result)) {
    return false;
  }
  $return = array();
  while ($row = mysql_fetch_array($result)) {
    $return[$row[ip]] = $row[count];
  }
  if ($ipsort) {
    $temp = array();
    foreach ($return as $key => $val) {
      $temp[zero_IP($key)] = $val;
    }
    ksort($temp);
    $return = array();
    foreach ($temp as $key => $val) {
      $return[normalize_IP($key)] = $val;
    }
  } else {
    arsort($return);
  }
  return $return;
}

/**
* Insert new IP in the Loggrep cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip   IP address to insert
* @return   mixed       on success integer with the id, else false
* @global   $db
* @access   public
* @see      db_lg_get_ips(), db_lg_get_id()
*/
function db_lg_new_ip($ip) {
  global $db;

  $result = mysql_query(
    "INSERT INTO lg_ip (ip) VALUES('$ip')",
    $db
  );
  if (! $result) {
    return false;
  } else {
    return db_lg_get_id($ip);
  }
}

/**
* Get all logged events for a certain IP/id for Loggrep.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which  IP address or id
* @return   mixed       on success array with the events as follows:
*                       $return = array(
*                         index => array(
*                           "year" => "yyyy",
*                           "month" => "mm",
*                           "day" => "dd",
*                           "time" => "hh:mm:ss",
*                           "srcport" => srcport,
*                           "destport" => destport
*                         )
*                       ), else false
* @global   $db
* @access   public
* @see      db_lg_new_log(), db_lg_get_id()
*/
function db_lg_get_log($which) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_lg_get_id($which);
  } else {
    $id = $which;
  }
  $result = mysql_query(
    "SELECT datetime,srcport,destport FROM lg_cache WHERE id=$id ORDER BY datetime",
    $db
  );
  if (! $result) {
    return false;
  }
  if (! mysql_num_rows($result)) {
    return false;
  }
  $return = array();
  while ($row = mysql_fetch_array($result)) {
    $return[] = array(
      "year" => substr($row[datetime], 0, 4),
      "month" => substr($row[datetime], 5, 2),
      "day" => substr($row[datetime], 8, 2),
      "time" => substr($row[datetime], 11, 8),
      "srcport" => $row[srcport],
      "destport" => $row[destport]
    );
  }
  return $return;
}

/**
* Insert new event in the Loggrep cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which    IP address or id
* @param    string      $datetime date and time in the format "yyyy-mm-dd hh:mm:ss"
* @param    integer     $srcport  source port
* @param    integer     $destport destination port
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_log()
*/
function db_lg_new_log($which, $datetime, $srcport, $destport) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_lg_get_id($which);
  } else {
    $id = $which;
  }
  $result = mysql_query(
    "INSERT INTO lg_cache (
      id,
      datetime,
      srcport,
      destport
    ) VALUES(
      $id,
      '$datetime',
      $srcport,
      $destport
    )"
  );
  if ($result) {
    return true;
  } else {
    user_error("INSERT INTO lg_cache failed: id ($id), datetime ($datetime), srcport ($srcport), destport ($destport)".($err = mysql_error($db) ? ". MySQL error: \"$err\"" : ""));
    return false;
  }
}

/**
* Increment the count of the number of events for a certain IP/id in the Loggrep cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which    IP address or id
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_id()
*/
function db_lg_inc_count($which) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_lg_get_id($which);
  } else {
    $id = $which;
  }
  $result = mysql_query(
    "UPDATE lg_ip SET count=count+1 WHERE id=$id",
    $db
  );
  if (! $result) {
    return false;
  }
  return true;
}

/**
* Get the last Prelude access time (so you know whether there are new events).
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed       on success string in the format "yyyy-mm-dd hh:mm:ss",
*                       else false
* @global   $db
* @access   public
* @see      db_prelude_set_last_access()
*/
function db_prelude_get_last_access() {
  global $db;

  $result = mysql_query("SELECT prelude_access FROM last", $db);
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) > 1) {
        die("There may be only one...");
      } else {
        $row = mysql_fetch_row($result);
        return $row[0];
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Set the last access time for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_prelude_get_last_access()
*/
function db_prelude_set_last_access($when) {
  global $db;

  $result = mysql_query(
    "UPDATE last SET prelude_access='$when'",
    $db
  );
  if (! $result) {
    $result = mysql_query(
      "INSERT INTO last SET prelude_access='$when'",
      $db
    );
    if ($result) {
      return true;
    } else {
      return false;
    }
  } else {
    return true;
  }
}

/**
* Get the time of the last inserted event (so you know which Prelude events have to be cached).
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed       on success string in the format "yyyy-mm-dd",
*                       else false
* @global   $db
* @access   public
* @see      db_prelude_set_last_insert()
*/
function db_prelude_get_last_insert() {
  global $db;

  $result = mysql_query("SELECT prelude_insert FROM last", $db);
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) == 1) {
        $row = mysql_fetch_row($result);
        return $row[0];
      } else {
        return false;
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Set the last insert time for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_prelude_get_last_insert()
*/
function db_prelude_set_last_insert($time) {
  global $db;

  if (! $time) {
    $time = "NOW()";
  } else {
    $time = "'$time'";
  }
  $result = mysql_query(
    "UPDATE last SET prelude_insert=$time",
    $db
  );
  if ($result) {
    return true;
  } else {
    $result = mysql_query(
      "INSERT INTO last SET prelude_insert=$time",
      $db
    );
    if ($result) {
      return true;
    } else {
      return false;
    }
  }
}

/**
* Get the id of a certain IP for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip   the IP address for which you want to know the id
* @return   mixed       on success integer with id, else false
* @global   $db
* @access   public
* @see      db_prelude_get_ip()
*/
function db_prelude_get_id($ip) {
  global $db;

  $result = mysql_query(
    "SELECT id FROM prelude_ip WHERE ip='$ip'",
    $db
  );
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) == 1) {
        $row = mysql_fetch_row($result);
        return $row[0];
      } else {
        die("IP address not unique in prelude_ip table");
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Get the IP of a certain id for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    integer     $id   the id for which you want to know the IP address
* @return   mixed       on success string with IP, else false
* @global   $db
* @access   public
* @see      db_prelude_get_id()
*/
function db_prelude_get_ip($id) {
  global $db;

  $result = mysql_query(
    "SELECT ip FROM prelude_ip WHERE id='$id'",
    $db
  );
  if ($result) {
    if (mysql_num_rows($result)) {
      if (mysql_num_rows($result) == 1) {
        $row = mysql_fetch_row($result);
        return $row[0];
      } else {
        die("id not unique in prelude_ip table");
      }
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
* Get all logged IPs from the cache for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @return   mixed       on success array with the IPs (IP => count), else false
* @global   $db
* @access   public
*/
function db_prelude_get_ips($ipsort = false) {
  global $db;

  $result = mysql_query(
    "SELECT ip,count FROM prelude_ip",
    $db
  );
  if (! $result) {
    return false;
  }
  if (! mysql_num_rows($result)) {
    return false;
  }
  $return = array();
  while ($row = mysql_fetch_array($result)) {
    $return[$row[ip]] = $row[count];
  }
  if ($ipsort) {
    $temp = array();
    foreach ($return as $key => $val) {
      $temp[zero_IP($key)] = $val;
    }
    ksort($temp);
    $return = array();
    foreach ($temp as $key => $val) {
      $return[normalize_IP($key)] = $val;
    }
  } else {
    arsort($return);
  }
  return $return;
}

/**
* Insert new IP in the cache for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip   IP address to insert
* @return   mixed       on success integer with the id, else false
* @global   $db
* @access   public
* @see      db_prelude_get_id()
*/
function db_prelude_new_ip($ip) {
  global $db;

  $result = mysql_query(
    "INSERT INTO prelude_ip (ip) VALUES('$ip')",
    $db
  );
  if (! $result) {
    return false;
  } else {
    return db_prelude_get_id($ip);
  }
}

/**
* Get all logged events for a certain IP/id for Prelude.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which  IP address or id
* @return   mixed       on success array with the events as follows:
*                       $return = array(
*                         index => array(
*                           "year" => "yyyy",
*                           "month" => "mm",
*                           "day" => "dd",
*                           "time" => "hh:mm:ss",
*                           "destip" => destip,
*                           "tcpsrc" => tcpsrc,
*                           "tcpdest" => tcpdest,
*                           "plugin" => "plugin",
*                           "received" => received,
*                           "message" => "message belonging to this item"
*                         )
*                       ), else false
* @global   $db
* @access   public
* @see      db_prelude_get_id(), db_prelude_new_log()
*/
function db_prelude_get_log($which) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_prelude_get_id($which);
  } else {
    $id = $which;
  }
  $result = mysql_query(
    "SELECT".
    "  datetime,".
    "  destip,".
    "  tcpsrc,".
    "  tcpdest,".
    "  icmptype,".
    "  icmpcode,".
    "  plugin,".
    "  received,".
    "  message ".
    "FROM prelude_cache WHERE id=$id ORDER BY datetime",
    $db
  );
  if (! $result) {
    return false;
  }
  if (! mysql_num_rows($result)) {
    return false;
  }
  $return = array();
  while ($row = mysql_fetch_array($result)) {
    $return[] = array(
      "year" => substr($row[datetime], 0, 4),
      "month" => substr($row[datetime], 5, 2),
      "day" => substr($row[datetime], 8, 2),
      "time" => substr($row[datetime], 11, 8),
      "destip" => $row[destip],
      "tcpsrc" => $row[tcpsrc],
      "tcpdest" => $row[tcpdest],
      "icmptype" => $row[icmptype],
      "icmpcode" => $row[icmpcode],
      "plugin" => $row[plugin],
      "received" => $row[received],
      "message" => $row[message]
    );
  }
  return $return;
}

/**
* Insert new event in the Prelude cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which    IP address or id
* @param    string      $datetime date and time in the format "yyyy-mm-dd hh:mm:ss"
* @param    string      $destip   destination IP address
* @param    integer     $tcpsrc   TCP source port
* @param    integer     $tcpdest  TCP destination port
* @param    string      $plugin   Which Prelude plugin
* @param    integer     $received how many times this item was received
* @param    string      $message  the message from the plugin about this item
* @param    integer     $icmptype ICMP type
* @param    integer     $icmpcode ICMP code
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_prelude_get_id(), db_prelude_get_log()
*/
function db_prelude_new_log(
  $which,
  $datetime,
  $destip,
  $tcpsrc,
  $tcpdest,
  $plugin,
  $received,
  $message,
  $icmptype = 0,
  $icmpcode = 0
) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_prelude_get_id($which);
  } else {
    $id = $which;
  }
  if (($icmptype) && (! $tcpsrc && ! $tcpdest)) {
    $result = mysql_query(
      "INSERT INTO prelude_cache (
        id,
        datetime,
        destip,
        icmptype,
        icmpcode,
        plugin,
        received,
        message
      ) VALUES (
        $id,
        '$datetime',
        '$destip',
        $icmptype,
        $icmpcode,
        '$plugin',
        $received,
        '$message'
      )"
    );
  } else {
    $result = mysql_query(
      "INSERT INTO prelude_cache (
        id,
        datetime,
        destip,
        tcpsrc,
        tcpdest,
        plugin,
        received,
        message
      ) VALUES (
        $id,
        '$datetime',
        '$destip',
        $tcpsrc,
        $tcpdest,
        '$plugin',
        $received,
        '$message'
      )"
    );
  }
  if ($result) {
    return true;
  } else {
    user_error("INSERT INTO prelude_cache failed: id ($id), datetime ($datetime), destip ($destip), tcpsrc ($tcpsrc), tcpdest ($tcpdest), icmp_type ($icmp_type), icmp_code ($icmp_code), plugin ($plugin), received ($received), message ($message), icmptype ($icmptype), icmpcode ($icmpcode)".($err = mysql_error($db) ? ". MySQL error: \"$err\"" : ""));
    return false;
  }
}

/**
* Increment the count of the number of events for a certain IP/id in the Prelude cache.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    mixed       $which    IP address or id
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_prelude_get_id()
*/
function db_prelude_inc_count($which) {
  global $db;

  if (ereg("^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$", $which)) {
    $id = db_prelude_get_id($which);
  } else {
    $id = $which;
  }
  $result = mysql_query(
    "UPDATE prelude_ip SET count=count+1 WHERE id=$id",
    $db
  );
  if (! $result) {
    return false;
  }
  return true;
}

/**
* Get the IPs that are in both the Loggrep and Prelude caches.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    boolean     $ipsort   true to sort on IP, false to sort on count (desc)
* @return   mixed       on success array with IPs, as follows:
*                       IP => array(lg_count, prelude_count)
*                       when not successful, returns false
* @global   $db
* @access   public
* @see      db_lg_get_ips(), db_prelude_get_ips()
*/
function db_get_ips($ipsort = false) {
  global $db;

  if ($ipsort) {
    $result = mysql_query(
      "SELECT".
      "  lg_ip.ip,".
      "  lg_ip.count AS lg_count,".
      "  prelude_ip.count AS prelude_count ".
      "FROM".
      "  lg_ip,".
      "  prelude_ip ".
      "WHERE".
      "  lg_ip.ip = prelude_ip.ip",
      $db
    );
  } else {
    $result = mysql_query(
      "SELECT".
      "  lg_ip.ip,".
      "  lg_ip.count AS lg_count,".
      "  prelude_ip.count AS prelude_count ".
      "FROM".
      "  lg_ip,".
      "  prelude_ip ".
      "WHERE".
      "  lg_ip.ip = prelude_ip.ip ".
      "ORDER BY lg_ip.count + prelude_ip.count DESC",
      $db
    );
  }
  if (! $result) {
    return false;
  }
  if (! mysql_num_rows($result)) {
    return false;
  }
  $return = array();
  while ($row = mysql_fetch_array($result)) {
    $return[$row[ip]] = array(
      "lg_count" => $row[lg_count],
      "prelude_count" => $row[prelude_count]
    );
  }
  if ($ipsort) {
    $temp = array();
    foreach ($return as $key => $val) {
      $temp[zero_IP($key)] = $val;
    }
    ksort($temp);
    $return = array();
    foreach ($temp as $key => $val) {
      $return[normalize_IP($key)] = $val;
    }
  }
  return $return;
}

/**
* Insert info of a new mail to Abuse about a certain IP/id.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip       IP address
* @param    string      $to_addr  email address of the Abuse Team where mail has been sent to
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_id(), db_prelude_get_id(), db_get_mail(), db_new_mailR()
*/
function db_new_mail($ip, $to_addr) {
  global $db;

  $lg_id = (int) db_lg_get_id($ip);
  $prelude_id = (int) db_prelude_get_id($ip);
  $result = mysql_query(
    "INSERT INTO abuse_email (".
    "  lg_id,".
    "  prelude_id,".
    "  datetime,".
    "  to_addr".
    ") VALUES (".
    "  $lg_id,".
    "  $prelude_id,".
    "  NOW(),".
    "  '$to_addr'".
    ")",
    $db
  );
  if ($result) {
    return true;
  } else {
    return false;
  }
}

/**
* Get info of all mails to Abuse about a certain IP/id.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip       IP address
* @return   mixed       on success array, as follows:
*                       [] => array(
*                         "year" => year,
*                         "month" => month,
*                         "day" => day,
*                         "time" => time,
*                         "to_addr" => to_addr
*                       )
*                       when unsuccessful, returns false
* @global   $db
* @access   public
* @see      db_lg_get_id(), db_prelude_get_id(), db_new_mail(), db_new_mailR()
*/
function db_get_mail($ip) {
  global $db;

  $lg_id = (int) db_lg_get_id($ip);
  $prelude_id = (int) db_prelude_get_id($ip);
  $where = ($lg_id ? "WHERE lg_id=$lg_id" : "");
  if (! $where) {
    $where = ($prelude_id ? "WHERE prelude_id=$prelude_id " : die("db_get_mail: no id found for $ip"));
  } else {
    $where .= ($prelude_id ? " || prelude_id=$prelude_id " : " ");
  }
  $result = mysql_query(
    "SELECT".
    "  datetime,".
    "  to_addr ".
    "FROM".
    "  abuse_email ".
    $where.
    "ORDER BY".
    "  datetime",
    $db
  );
  if ($result) {
    if (! mysql_num_rows($result)) {
      return false;
    }
    $return = array();
    while ($row = mysql_fetch_array($result)) {
      $return[] = array(
        "year" => substr($row[datetime], 0, 4),
        "month" => substr($row[datetime], 5, 2),
        "day" => substr($row[datetime], 8, 2),
        "time" => substr($row[datetime], 11, 8),
        "to_addr" => $row[to_addr]
      );
    }
    return $return;
  } else {
    return false;
  }
}

/**
* Insert info of several new mails to Abuse about a range of IPs at once.
*
* Note: of course only new mails info will be inserted regarding existent IP
*       addresses in the Loggrep and Prelude cache, not all IP addresses in the
*       range.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $range    range of IP addresses, as follows: "0.0.0.0-255.255.255.255"
* @param    string      $to_addr  email address of the Abuse Team where mail has been sent to
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_id(), db_prelude_get_id(), db_get_mail(), db_new_mail()
*/
function db_new_mailR($range, $to_addr) {
  global $db;

  $range = explode("-", $range);
  $IPs = array_keys(array_merge(lg_range_ips(), prelude_range_ips()));
  foreach ($IPs as $val) {
    $lg_id = (int) db_lg_get_id($val);
    $prelude_id = (int) db_prelude_get_id($val);
    $result = mysql_query(
      "INSERT INTO abuse_email (".
      "  lg_id,".
      "  prelude_id,".
      "  datetime,".
      "  to_addr".
      ") VALUES (".
      "  $lg_id,".
      "  $prelude_id,".
      "  NOW(),".
      "  '$to_addr'".
      ")",
      $db
    );
  }
}

/**
* Insert new note about a certain IP/id.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip       IP address
* @param    string      $note     the note itself
* @return   boolean     on success true, else false
* @global   $db
* @access   public
* @see      db_lg_get_id(), db_prelude_get_id(), db_get_notes()
*/
function db_new_note($ip, $note) {
  global $db;

  $lg_id = (int) db_lg_get_id($ip);
  $prelude_id = (int) db_prelude_get_id($ip);
  if (! $lg_id && ! $prelude_id) {
    return false;
  }
  $result = mysql_query(
    "INSERT INTO notes (lg_id,prelude_id,datetime,note) VALUES ($lg_id,$prelude_id,NOW(),'$note')",
    $db
  );
  if (! $result) {
    return false;
  }
  return true;
}

/**
* Get the notes about a certain IP/id.
*
* @author   Richard Vrijhof <R.J.Vrijhof@bigfoot.com>
* @param    string      $ip       IP address
* @return   mixed       on success array, as follows:
*                       [] => array(
*                         "year" => year,
*                         "month" => month,
*                         "day" => day,
*                         "time" => time,
*                         "note" => note
*                       )
*                       when unsuccessful, returns false
* @global   $db
* @access   public
* @see      db_lg_get_id(), db_prelude_get_id(), db_new_note()
*/
function db_get_notes($ip) {
  global $db;

  $lg_id = (int) db_lg_get_id($ip);
  $prelude_id = (int) db_prelude_get_id($ip);
  if (! $lg_id && ! $prelude_id) {
    return false;
  }
  $where = ($lg_id ? "WHERE lg_id=$lg_id" : "");
  if (! $where) {
    $where = ($prelude_id ? "WHERE prelude_id=$prelude_id " : die("db_get_mail: no id found for $ip"));
  } else {
    $where .= ($prelude_id ? " || prelude_id=$prelude_id " : " ");
  }
  $result = mysql_query(
    "SELECT datetime,note FROM notes $where",
    $db
  );
  if ($result) {
    if (! mysql_num_rows($result)) {
      return false;
    }
    $return = array();
    while ($row = mysql_fetch_array($result)) {
      $return[] = array(
        "year" => substr($row[datetime], 0, 4),
        "month" => substr($row[datetime], 5, 2),
        "day" => substr($row[datetime], 8, 2),
        "time" => substr($row[datetime], 11, 8),
        "note" => $row[note]
      );
    }
    return $return;
  } else {
    return false;
  }
}

?>
